/* Brake History Converter */
/* GNU CopyLeft by Victor Pashkevich, 2:451/30 */

parse arg arg1 arg2

/* arg1 - input .his file(s)
*/

if RxFuncQuery('SysLoadFuncs') then do
   call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
   call SysLoadFuncs
end

if arg1='' then do
   say 'Usage: HistConv *.his'
   exit 0
end

headersign.old=' This is VAGABONDO history file '
headersign.new=' This is VAGABONDO 1.1 history file '
trailer.old='0A'x||,
'040404'x||'                                              '||'0404040A'x||,
'20FE'x  ||' ----======================================---- '||'FE200A'x||,
'20FE'x  ||' - Copyright (c) 1994 John Gladkih, 2:5051/16 - '||'FE200A'x||,
'20FE'x  ||' ----======================================---- '||'FE200A'x||,
'040404'x||'                                              '||'0404040A'x
trailer.new='0A'x||,
'040404'x||'                                              '||'0404040A'x||,
'20FE'x  ||' ----======================================---- '||'FE200A'x||,
'20FE'x  ||' - Copyright (c) 1998 John Gladkih, 2:5051/16 - '||'FE200A'x||,
'20FE'x  ||' ----======================================---- '||'FE200A'x||,
'040404'x||'                                              '||'0404040A'x

cfgname=''
histlen=0
headerlen=174
signlen=length(headersign.old)
trailerlen=length(trailer.old)
histheader=''
histbody=''

   rc=SysFileTree(arg1,'file','FO')
   do current = 1 to file.0
     cfgname=file.current
     histlen=chars(cfgname)
     say cfgname': 'histlen
     if histlen < headerlen+trailerlen then do
        rc=CHAROUT(cfgname)
        say '  Ignoring: file length too short'
        say ''
        iterate
     end
     histheader=charin(cfgname,1,headerlen)
     histbody=charin(cfgname,,histlen-headerlen)
     rc=CHAROUT(cfgname)
     if CalcCRC(histheader,1,172) <> c2d(reverse(substr(histheader,173,2))) then do
        say '  Ignoring: header has invalid CRC'
        say ''
        iterate
     end
     rc=Convert()
   end

exit 0
/*-------------------------*/

/*- CalcCRC ---------------*/
CalcCRC:
   PARSE ARG _buf,_start,_len
   crc=0
   do i=1 to _len
     crc=crc+c2d(substr(_buf,_start+i-1,1))
   end
return crc
/*-------------------------*/

/*- Convert ---------------*/
Convert:
   headerdata=substr(histheader,signlen+1,headerlen-signlen-2)
   headerdata=insert('00000000'x,headerdata,length(headerdata)-32)
   histnew=headersign.new||headerdata
   histnew=histnew||reverse(d2c(CalcCRC(histnew,1,length(histnew))))
   histnew=histnew||substr(histbody,1,length(histbody)-trailerlen)||trailer.new
   '@del /f 'cfgname
   rc=charout(cfgname,histnew)
   rc=charout(cfgname)
return 0
/*-------------------------*/
