#if defined(__OS2__)
#  define Cdecl
#else
#  define Cdecl cdecl
#endif

typedef unsigned long big;
typedef unsigned short index;

const unsigned short MaxItems = 0xffff/sizeof(void *);
extern int completeCode;

// Current statistics

struct InfoStr
{
  big dial, answer, income, outcome, external, bbs, terminal;
  unsigned short usedCount;
};

extern InfoStr info[48];

struct NodeInfo
{
  char *domain;
  unsigned short zone, net, node, point;
  big ioTime;
  big sent, received;
  big income, outcome, inSession, outSession;
  big bbs;
  big inMail, inXmail, inFiles,
      outMail, outXmail, outFiles;
};

extern NodeInfo **nodesInfo;
extern index totalNodes;

struct IOInfo
{
  char *name;
  big count, total;
};

extern IOInfo **ioInfo;
extern index totalIO;

extern big inSessions, outSessions,
           inHand, outHand,
           startTime, endTime,
           totalDialing, totalAnswering,
           totalIncome, totalOutcome,
           totalExternal,
           totalBBS,
           totalTerminal,
           totalBytesIn, totalBytesOut,
           inMail, inXmail, inFiles,
           outMail, outXmail, outFiles,
           sesFTS0001, sesWaZOO, sesEMSI, sesXZ;

// LOG parser declaration

enum LOGStyle { logUnknownStyle=0, logBinkStyle, logTMStyle, logBrakeStyle };

enum SessionType { WhoKnown = 0, FTS0001, WaZOO, EMSI };

enum FileType { Undefined=0, Mail, Xmail, Files };

extern char logStart[ 16 ],
	    logEnd[ sizeof(logStart) ];

extern long logLines,
	    skipLines;

extern char line[256], tag;
extern char getSkip;
extern big stamp, actionStarted;

// Hystory file

#define hystHeaderSign    "\04\xfa This is VAGABONDO 1.1 history file \xfa\04"
#define hystHeaderSignOld "\04\xfa This is VAGABONDO history file \xfa\04"

struct HystHeader
{
  char sign[ sizeof(hystHeaderSign)-1 ];
  big date;
  big init;
  big lines;
  big size;
  big inSessions, outSessions,
      inHand, outHand,
      totalDialing, totalAnswering,
      totalIncome, totalOutcome,
      totalExternal,
      totalBBS,
      totalTerminal,
      totalBytesIn, totalBytesOut,
      inMail, inXmail, inFiles,
      outMail, outXmail, outFiles,
      sesFTS0001, sesWaZOO, sesEMSI, sesXZ;
char hLogStart[ sizeof(logStart) ],
     hLogEnd[ sizeof(logStart) ];
  unsigned short crc;
};

struct HystHeaderOld
{
  char sign[ sizeof(hystHeaderSignOld)-1 ];
  big date;
  big init;
  big lines;
  big size;
  big inSessions, outSessions,
      inHand, outHand,
      totalDialing, totalAnswering,
      totalIncome, totalOutcome,
      totalExternal,
      totalBBS,
      totalTerminal,
      totalBytesIn, totalBytesOut,
      inMail, inXmail, inFiles,
      outMail, outXmail, outFiles,
      sesFTS0001, sesWaZOO, sesEMSI;
char hLogStart[ sizeof(logStart) ],
     hLogEnd[ sizeof(logStart) ];
  unsigned short crc;
};

extern HystHeader hystHeader;

extern HystHeaderOld hystHeaderOld;

extern InfoStr hystInfo[48];
extern NodeInfo **hystNodes;
extern index hystTotalNodes;
extern IOInfo **hystIoInfo;
extern index hystTotalIO;

extern char useHysto,
            useTraff,
            useSess,
            debugMode;

extern char *logName,
            *statName,
            *hystName,
            *hystNameOld;

extern FILE *logFile,
            *statFile,
            *hystFile,
            *hystFileOld;

extern char *progName;

void loadHystory( char *hystoryName );
void storeHystory();

enum StorageType { FileMsg=0, FidoMsg=1, JAMMsg=2 };

extern StorageType storageType;

void checkPtr( void *addr );
void returnToDos( int );

#define PAIR( x, y ) ( (((int)(y))<<8)|(x) )
