#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#include "busy.h"

const char *finitaLaComedia =
      "\n\04\04\04                                              \04\04\04\n"
      " \xfe ----======================================---- \xfe \n"
      " \xfe - Copyright (c) 1998 John Gladkih, 2:5051/16 - \xfe \n"
      " \xfe ----======================================---- \xfe \n"
      "\04\04\04                                              \04\04\04\n";

const char *finitaLaComediaOld =
      "\n\04\04\04                                              \04\04\04\n"
      " \xfe ----======================================---- \xfe \n"
      " \xfe - Copyright (c) 1994 John Gladkih, 2:5051/16 - \xfe \n"
      " \xfe ----======================================---- \xfe \n"
      "\04\04\04                                              \04\04\04\n";

char *newStr( char *s )
{
  if( s==NULL )
    return NULL;

  char *n( new char [ strlen(s)+1 ] );

  strcpy( n, s );
  return n;
}

int hystTrail()
{

  if( fwrite( finitaLaComedia, 1, strlen(finitaLaComedia), hystFile )!=strlen(finitaLaComedia) )
    return 1;

  fwrite( finitaLaComedia, 1, 0, hystFile );

  return 0;

}

void makeHeaderCRC()
{
  register unsigned char *p( (unsigned char *)&hystHeader );
  hystHeader.crc = 0;
  for( size_t i=0; i<sizeof(hystHeader)-sizeof(hystHeader.crc); i++, p++ )
    hystHeader.crc += (unsigned short)*p;
}

void makeHeaderCRCOld()
{
  register unsigned char *p( (unsigned char *)&hystHeaderOld );
  hystHeaderOld.crc = 0;
  for( size_t i=0; i<sizeof(hystHeaderOld)-sizeof(hystHeaderOld.crc); i++, p++ )
    hystHeaderOld.crc += (unsigned short)*p;
}

void loadHystory( char *hystoryName )
{
  char * mode;
  big _fsize;

  if( access( hystoryName, 0 ) )
  {
    printf( "Initialize history file `%s'\n", hystoryName );
    mode = "w+b";
  }
  else
  {
    printf( "Loading history from file `%s'\n", hystoryName );
    mode = "r+b";
  }

  hystFile = fopen( hystoryName, mode );

  if( hystFile==NULL )
  {
    printf("Error encountered reading file %s.\n", hystoryName );
    returnToDos(5);
  }

  setbuf( hystFile, NULL );

  _fsize = filelength( fileno( hystFile ) );
  if( _fsize )
  {
    if( (unsigned)_fsize <
	 (unsigned) sizeof(hystHeaderOld) + sizeof(info) +
                    sizeof(totalNodes) + sizeof(totalIO) )
      goto format;

    if( fread( &hystHeaderOld, 1, sizeof(hystHeaderOld), hystFile )!=sizeof(hystHeaderOld) )
    {
cant_load:
      char *msg( "Can't load history" );
      if( feof(hystFile) )
        printf( "*Fatal* %s - unexpected EOF\n", msg );
      else
        printf("Error encountered reading file %s.\n", hystoryName );
      returnToDos(5);
    }

    if( memcmp( hystHeaderOld.sign, hystHeaderSignOld, sizeof(hystHeaderOld.sign) ) )
    {
format:
      printf( "*Fatal* Illegal history file format\n" );
      returnToDos(5);
    }

    unsigned short crc = hystHeaderOld.crc;
    makeHeaderCRCOld();
    if( hystHeaderOld.crc!=crc )
    {
      printf( "*Fatal* Illegal history file header CRC\n" );
      returnToDos(5);
    }

    if( fread( &hystInfo, 1, sizeof(hystInfo), hystFile )!=sizeof(hystInfo) )
      goto cant_load;

    if( fread( &hystTotalNodes, 1, sizeof(hystTotalNodes), hystFile )!=sizeof(hystTotalNodes) )
      goto cant_load;

    if( hystTotalNodes )
    {

      hystNodes = (NodeInfo **)malloc( sizeof(NodeInfo **)*hystTotalNodes );
      checkPtr( hystNodes );

      for( index j=0; j<hystTotalNodes; j++ )
      {

        NodeInfo *newNode( new NodeInfo );
        checkPtr( newNode );

	hystNodes[j] = newNode;

	if( fread( newNode, 1, sizeof(NodeInfo), hystFile )!=sizeof(NodeInfo) )
          goto cant_load;

        char len( 0 );

	if( fread( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
          goto cant_load;

        if( len )
        {
          newNode->domain = new char [len+1];
          checkPtr( newNode->domain );
	  if( (unsigned)fread( newNode->domain, 1, len, hystFile )!=(unsigned)len )
            goto cant_load;
          newNode->domain[len] = 0;
        }
        else
          newNode->domain = newStr( "" );

      }

    }

    if( fread( &hystTotalIO, 1, sizeof(hystTotalIO), hystFile )!=sizeof(hystTotalIO) )
      goto cant_load;

    if( hystTotalIO )
    {

      hystIoInfo = (IOInfo **)malloc( sizeof(IOInfo **)*hystTotalIO );
      checkPtr( hystIoInfo );

      for( index j=0; j<hystTotalIO; j++ )
      {

        IOInfo *newIO( new IOInfo );
        checkPtr( newIO );

	hystIoInfo[j] = newIO;

	if( fread( newIO, 1, sizeof(IOInfo), hystFile )!=sizeof(IOInfo) )
          goto cant_load;

        char len( 0 );

	if( fread( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
          goto cant_load;

        if( len )
        {
          newIO->name = new char [len+1];
          checkPtr( newIO->name );
	  if( (unsigned)fread( newIO->name, 1, len, hystFile )!=(unsigned)len )
            goto cant_load;
          newIO->name[len] = 0;
        }
        else
          newIO->name = newStr( "*Unloaded*" );

      }

    }

    for( int i=0, j=0; (unsigned)i<(unsigned)strlen(finitaLaComediaOld); i++ )
      if( (j=fgetc( hystFile ),j)==EOF || char(j)!=finitaLaComediaOld[i] )
        goto format;

    if( fgetc( hystFile )!=EOF )
    {
      printf( "*Fatal* Too long history file\n" );
      returnToDos(5);
    }

  }
  else
  {

    memset( &hystHeaderOld, 0, sizeof(hystHeaderOld) );
    memcpy( hystHeaderOld.sign, hystHeaderSignOld, sizeof(hystHeaderOld.sign) );

    makeHeaderCRCOld();

    fseek( hystFile, 0, SEEK_SET );

    if( fwrite( &hystHeaderOld, 1, sizeof(hystHeaderOld), hystFile )!=sizeof(hystHeaderOld) )
    {
cant_init:
      puts( "Can't initialize hystory file" );
      returnToDos(5);
    }

    if( fwrite( &info, 1, sizeof(info), hystFile )!=sizeof(info) )
      goto cant_init;

    if( fwrite( &totalNodes, 1, sizeof(totalNodes), hystFile )!=sizeof(totalNodes) )
      goto cant_init;

    if( fwrite( &totalIO, 1, sizeof(totalIO), hystFile )!=sizeof(totalIO) )
      goto cant_init;

    if( hystTrail() )
      goto cant_init;

  }

}

void storeHystory()
{

  printf( "Storing history to file `%s'\n", hystName );

  fseek( hystFile, 0, SEEK_SET );

  if( fwrite( &hystHeader, 1, sizeof(hystHeader), hystFile )!=sizeof(hystHeader) )
  {
cant_store:
    puts( "Can't store history" );
    return;
  }

  if( fwrite( &info, 1, sizeof(info), hystFile )!=sizeof(info) )
    goto cant_store;

  if( fwrite( &totalNodes, 1, sizeof(totalNodes), hystFile )!=sizeof(totalNodes) )
    goto cant_store;

  index j;

  for( j=0; j<totalNodes; j++ )
  {

    if( fwrite( nodesInfo[j], 1, sizeof(NodeInfo), hystFile )!=sizeof(NodeInfo) )
      goto cant_store;

    char len( 0 );

    if( nodesInfo[j]->domain!=NULL )
      len = (char)strlen( nodesInfo[j]->domain );

    if( fwrite( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
      goto cant_store;

    if( len )
      if( (unsigned)fwrite( nodesInfo[j]->domain, 1, len, hystFile )!=(unsigned)len )
        goto cant_store;

  }

  if( fwrite( &totalIO, 1, sizeof(totalIO), hystFile )!=sizeof(totalIO) )
    goto cant_store;

  for( j=0; j<totalIO; j++ )
  {

    if( fwrite( ioInfo[j], 1, sizeof(IOInfo), hystFile )!=sizeof(IOInfo) )
      goto cant_store;

    char len( 0 );

    if( ioInfo[j]->name!=NULL )
      len = (char)strlen( ioInfo[j]->name );

    if( fwrite( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
      goto cant_store;

    if( len )
      if( (unsigned)fwrite( ioInfo[j]->name, 1, len, hystFile )!=(unsigned)len )
        goto cant_store;

  }

  if( hystTrail() )
    goto cant_store;

}

